<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsShipmentTraceWithImages ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsShipmentTraceWithImages extends AbstractStructArrayBase
{
    /**
     * The clsShipmentTraceWithImages
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsShipmentTraceWithImages[]
     */
    public $clsShipmentTraceWithImages;
    /**
     * Constructor method for ArrayOfClsShipmentTraceWithImages
     * @uses ArrayOfClsShipmentTraceWithImages::setClsShipmentTraceWithImages()
     * @param \StructType\ClsShipmentTraceWithImages[] $clsShipmentTraceWithImages
     */
    public function __construct(array $clsShipmentTraceWithImages = array())
    {
        $this
            ->setClsShipmentTraceWithImages($clsShipmentTraceWithImages);
    }
    /**
     * Get clsShipmentTraceWithImages value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsShipmentTraceWithImages[]|null
     */
    public function getClsShipmentTraceWithImages()
    {
        return isset($this->clsShipmentTraceWithImages) ? $this->clsShipmentTraceWithImages : null;
    }
    /**
     * Set clsShipmentTraceWithImages value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsShipmentTraceWithImages[] $clsShipmentTraceWithImages
     * @return \ArrayType\ArrayOfClsShipmentTraceWithImages
     */
    public function setClsShipmentTraceWithImages(array $clsShipmentTraceWithImages = array())
    {
        foreach ($clsShipmentTraceWithImages as $arrayOfClsShipmentTraceWithImagesClsShipmentTraceWithImagesItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsShipmentTraceWithImagesClsShipmentTraceWithImagesItem instanceof \StructType\ClsShipmentTraceWithImages) {
                throw new \InvalidArgumentException(sprintf('The clsShipmentTraceWithImages property can only contain items of \StructType\ClsShipmentTraceWithImages, "%s" given', is_object($arrayOfClsShipmentTraceWithImagesClsShipmentTraceWithImagesItem) ? get_class($arrayOfClsShipmentTraceWithImagesClsShipmentTraceWithImagesItem) : gettype($arrayOfClsShipmentTraceWithImagesClsShipmentTraceWithImagesItem)), __LINE__);
            }
        }
        if (is_null($clsShipmentTraceWithImages) || (is_array($clsShipmentTraceWithImages) && empty($clsShipmentTraceWithImages))) {
            unset($this->clsShipmentTraceWithImages);
        } else {
            $this->clsShipmentTraceWithImages = $clsShipmentTraceWithImages;
        }
        return $this;
    }
    /**
     * Add item to clsShipmentTraceWithImages value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsShipmentTraceWithImages $item
     * @return \ArrayType\ArrayOfClsShipmentTraceWithImages
     */
    public function addToClsShipmentTraceWithImages(\StructType\ClsShipmentTraceWithImages $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsShipmentTraceWithImages) {
            throw new \InvalidArgumentException(sprintf('The clsShipmentTraceWithImages property can only contain items of \StructType\ClsShipmentTraceWithImages, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->clsShipmentTraceWithImages[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsShipmentTraceWithImages|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsShipmentTraceWithImages|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsShipmentTraceWithImages|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsShipmentTraceWithImages|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsShipmentTraceWithImages|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsShipmentTraceWithImages
     */
    public function getAttributeName()
    {
        return 'clsShipmentTraceWithImages';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsShipmentTraceWithImages
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
