<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'getShipmentTrace' => '\\StructType\\GetShipmentTrace',
            'getShipmentTraceResponse' => '\\StructType\\GetShipmentTraceResponse',
            'clsShipmentTrace' => '\\StructType\\ClsShipmentTrace',
            'clsShipmentTraceBase' => '\\StructType\\ClsShipmentTraceBase',
            'SdgiData' => '\\StructType\\SdgiData',
            'ArrayOfClsTrace' => '\\ArrayType\\ArrayOfClsTrace',
            'clsTrace' => '\\StructType\\ClsTrace',
            'ArrayOfClsTraceDetails' => '\\ArrayType\\ArrayOfClsTraceDetails',
            'clsTraceDetails' => '\\StructType\\ClsTraceDetails',
            'getShipmentTraceAsArray' => '\\StructType\\GetShipmentTraceAsArray',
            'getShipmentTraceAsArrayResponse' => '\\ArrayType\\GetShipmentTraceAsArrayResponse',
            'ArrayOfClsShipmentTrace' => '\\ArrayType\\ArrayOfClsShipmentTrace',
            'getShipmentTraceByLanguageAsArray' => '\\StructType\\GetShipmentTraceByLanguageAsArray',
            'getShipmentTraceByLanguageAsArrayResponse' => '\\ArrayType\\GetShipmentTraceByLanguageAsArrayResponse',
            'getShipmentTraceWithImages' => '\\StructType\\GetShipmentTraceWithImages',
            'getShipmentTraceWithImagesResponse' => '\\StructType\\GetShipmentTraceWithImagesResponse',
            'ArrayOfClsShipmentTraceWithImages' => '\\ArrayType\\ArrayOfClsShipmentTraceWithImages',
            'clsShipmentTraceWithImages' => '\\StructType\\ClsShipmentTraceWithImages',
            'ArrayOfImage' => '\\ArrayType\\ArrayOfImage',
            'Image' => '\\StructType\\Image',
            'getShipmentTraceByReference' => '\\StructType\\GetShipmentTraceByReference',
            'getShipmentTraceByReferenceResponse' => '\\StructType\\GetShipmentTraceByReferenceResponse',
            'getShipmentTraceByReferenceAsArray' => '\\StructType\\GetShipmentTraceByReferenceAsArray',
            'getShipmentTraceByReferenceAsArrayResponse' => '\\ArrayType\\GetShipmentTraceByReferenceAsArrayResponse',
            'getShipmentTraceByReferenceAndLanguageAsArray' => '\\StructType\\GetShipmentTraceByReferenceAndLanguageAsArray',
            'getShipmentTraceByReferenceAndLanguageAsArrayResponse' => '\\ArrayType\\GetShipmentTraceByReferenceAndLanguageAsArrayResponse',
            'getShipmentTraceByReferenceWithImages' => '\\StructType\\GetShipmentTraceByReferenceWithImages',
            'getShipmentTraceByReferenceWithImagesResponse' => '\\StructType\\GetShipmentTraceByReferenceWithImagesResponse',
            'getShipmentTraceByReferenceGlobal' => '\\StructType\\GetShipmentTraceByReferenceGlobal',
            'getShipmentTraceByReferenceGlobalResponse' => '\\StructType\\GetShipmentTraceByReferenceGlobalResponse',
            'getShipmentTraceByReferenceGlobalAsArray' => '\\StructType\\GetShipmentTraceByReferenceGlobalAsArray',
            'getShipmentTraceByReferenceGlobalAsArrayResponse' => '\\ArrayType\\GetShipmentTraceByReferenceGlobalAsArrayResponse',
            'getShipmentTraceByReferenceGlobalWithCenterAsArray' => '\\StructType\\GetShipmentTraceByReferenceGlobalWithCenterAsArray',
            'getShipmentTraceByReferenceGlobalWithCenterAsArrayResponse' => '\\ArrayType\\GetShipmentTraceByReferenceGlobalWithCenterAsArrayResponse',
            'getShipmentTraceByReferenceAndLanguageGlobalAsArray' => '\\StructType\\GetShipmentTraceByReferenceAndLanguageGlobalAsArray',
            'getShipmentTraceByReferenceAndLanguageGlobalAsArrayResponse' => '\\ArrayType\\GetShipmentTraceByReferenceAndLanguageGlobalAsArrayResponse',
            'getShipmentTraceByReferenceGlobalWithImages' => '\\StructType\\GetShipmentTraceByReferenceGlobalWithImages',
            'getShipmentTraceByReferenceGlobalWithImagesResponse' => '\\StructType\\GetShipmentTraceByReferenceGlobalWithImagesResponse',
            'getShipmentTraceByDPDReferenceGlobalAsArray' => '\\StructType\\GetShipmentTraceByDPDReferenceGlobalAsArray',
            'getShipmentTraceByDPDReferenceGlobalAsArrayResponse' => '\\ArrayType\\GetShipmentTraceByDPDReferenceGlobalAsArrayResponse',
        );
    }
}
